unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, Menus, StdCtrls, appcontrol, unit2, unit4;

type

  { TApplicationForm }

  TApplicationForm = class(TForm)
    ApplicationImage: TImage;
    ApplicationToolbar: TToolBar;
    ApplicationToolbarImages: TImageList;
    ApplicationFormMainMenu: TMainMenu;
    EventPopupMenu: TPopupMenu;
    EventPUMEditSymbols: TMenuItem;
    EventPUMRotate: TMenuItem;
    EventPUMSep1: TMenuItem;
    EventPUMDelete: TMenuItem;
    EventPUMDisplayLabel: TMenuItem;
    ApplicationMenubarImages: TImageList;
    ApplicationStatemenuImages: TImageList;
    ApplicationEventmenuImages: TImageList;
    MachineSaveDialog: TSaveDialog;
    MachineOpenDialog: TOpenDialog;
    EventPUMSetRadius: TMenuItem;
    MMAbout: TMenuItem;
    StatePUMDelete: TMenuItem;
    StatePUMSep2: TMenuItem;
    StatePUMSep1: TMenuItem;
    StatePUMFSRotateArrow: TMenuItem;
    StatePUMFirstSub: TMenuItem;
    StatePUMMakeFirst: TMenuItem;
    StatePUMFailAndEndState: TMenuItem;
    StatePUMAcceptAndEndState: TMenuItem;
    StatePUMAcceptState: TMenuItem;
    StatePUMNormalState: TMenuItem;
    MMSep3: TMenuItem;
    MMCloseMachine: TMenuItem;
    MMLangEnglish: TMenuItem;
    MMLangDefault: TMenuItem;
    MMLanguage: TMenuItem;
    MMSettings: TMenuItem;
    MMExit: TMenuItem;
    MMSep2: TMenuItem;
    MMOpenMachine: TMenuItem;
    MMSaveMachineAs: TMenuItem;
    MMSaveMachine: TMenuItem;
    MMSep1: TMenuItem;
    MMFile: TMenuItem;
    MMNewMachine: TMenuItem;
    StatePopupMenu: TPopupMenu;
    SBHorizontal: TScrollBar;
    SBVertical: TScrollBar;
    TBSelect: TToolButton;
    TBDiv1: TToolButton;
    TBNewState: TToolButton;
    TBNewEventLine: TToolButton;
    TBDiv2: TToolButton;
    TBFitToGrid: TToolButton;
    TBDiv3: TToolButton;
    TBTestSentence: TToolButton;
    TBTestSentenceAnim: TToolButton;
    procedure ApplicationImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ApplicationImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ApplicationImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EventPUMDeleteClick(Sender: TObject);
    procedure EventPUMDisplayLabelClick(Sender: TObject);
    procedure EventPUMEditSymbolsClick(Sender: TObject);
    procedure EventPUMRotateClick(Sender: TObject);
    procedure EventPUMSetRadiusClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MMAboutClick(Sender: TObject);
    procedure MMExitClick(Sender: TObject);
    procedure MMOpenMachineClick(Sender: TObject);
    procedure MMSaveMachineAsClick(Sender: TObject);
    procedure MMSaveMachineClick(Sender: TObject);
    procedure StatePUMAcceptAndEndStateClick(Sender: TObject);
    procedure StatePUMAcceptStateClick(Sender: TObject);
    procedure StatePUMDeleteClick(Sender: TObject);
    procedure StatePUMFailAndEndStateClick(Sender: TObject);
    procedure MMCloseMachineClick(Sender: TObject);
    procedure MMLangDefaultClick(Sender: TObject);
    procedure MMLangEnglishClick(Sender: TObject);
    procedure MMNewMachineClick(Sender: TObject);
    procedure SBHorizontalKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SBHorizontalScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure SBVerticalKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SBVerticalScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure StatePUMFSRotateArrowClick(Sender: TObject);
    procedure StatePUMMakeFirstClick(Sender: TObject);
    procedure StatePUMNormalStateClick(Sender: TObject);
    procedure TBFitToGridClick(Sender: TObject);
    procedure TBNewEventLineClick(Sender: TObject);
    procedure TBNewStateClick(Sender: TObject);
    procedure TBSelectClick(Sender: TObject);
    procedure TBTestSentenceAnimClick(Sender: TObject);
    procedure TBTestSentenceClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure OnAnimationDone;
    procedure OnResizeTick;
  end; 

var
  ApplicationForm: TApplicationForm;
  App: TApplicationControl;

implementation

uses
  appgraphic;

var
  StateMovement: Boolean;

{$R *.lfm}

procedure SetInterfaceGraphics(App: TApplicationControl);
var
  GL: TGraphicLibrary;
  I: Integer;
begin
  GL := App.GetGraphic;
  if GL = nil then Exit;

  if GL['Toolbar_icons'] <> nil then
  begin
    ApplicationForm.ApplicationToolbarImages.Clear;
    I := 0;
    while GL['Toolbar_icons'][I] <> nil do
    begin
      ApplicationForm.ApplicationToolbarImages.Add(GL['Toolbar_icons'][I],nil);
      Inc(I);
    end;
  end;

  if GL['Mainmenu_icons'] <> nil then
  begin
    ApplicationForm.ApplicationMenubarImages.Clear;
    I := 0;
    while GL['Mainmenu_icons'][I] <> nil do
    begin
      ApplicationForm.ApplicationMenubarImages.Add(GL['Mainmenu_icons'][I],nil);
      Inc(I);
    end;
  end;

  if GL['Statemenu_icons'] <> nil then
  begin
    ApplicationForm.ApplicationStatemenuImages.Clear;
    I := 0;
    while GL['Statemenu_icons'][I] <> nil do
    begin
      ApplicationForm.ApplicationStatemenuImages.Add(GL['Statemenu_icons'][I],nil);
      Inc(I);
    end;
  end;

  if GL['Eventmenu_icons'] <> nil then
  begin
    ApplicationForm.ApplicationEventmenuImages.Clear;
    I := 0;
    while GL['Eventmenu_icons'][I] <> nil do
    begin
      ApplicationForm.ApplicationEventmenuImages.Add(GL['Eventmenu_icons'][I],nil);
      Inc(I);
    end;
  end;
end;

{
  Zmeni velkost grafickej plochy
}
procedure ReinitializeApplicationImage;
begin
  // Zavola zmenu rozmerov okna
  App.CallResizeScreen;

  //App.RenderAll;
  App.ForceRenderNextTime;
end;

procedure RefreshTranslationTexts;
begin
  // Menu
  ApplicationForm.MMFile.Caption := App.Trans['menufile'];
  ApplicationForm.MMExit.Caption := App.Trans['menuexit'];
  ApplicationForm.MMNewMachine.Caption := App.Trans['menunewmachine'];
  ApplicationForm.MMSaveMachine.Caption := App.Trans['menusavemachine'];
  ApplicationForm.MMCloseMachine.Caption := App.Trans['menuclosemachine'];
  ApplicationForm.MMSaveMachineAs.Caption := App.Trans['menusavemachineas'];
  ApplicationForm.MMOpenMachine.Caption := App.Trans['menuopenmachine'];
  ApplicationForm.MMSettings.Caption := App.Trans['menusettings'];
  ApplicationForm.MMLanguage.Caption := App.Trans['menulanguage'];
  ApplicationForm.MMLangDefault.Caption := App.Trans['menulangslovak'];
  ApplicationForm.MMLangEnglish.Caption := App.Trans['menulangenglish'];
  ApplicationForm.MMAbout.Caption := App.Trans['menuabout'];

  // Form
  if App.FileName = '' then
    ApplicationForm.Caption := App.Trans['appformcaption']
  else
    ApplicationForm.Caption := App.Trans['appformcaption'] + ' - ' + App.FileName;

  // Toolbar
  ApplicationForm.TBSelect.Caption := App.Trans['toolbarselect'];
  ApplicationForm.TBSelect.Hint := App.Trans['toolbarselect'] + ' (F2)';
  ApplicationForm.TBNewState.Caption := App.Trans['toolbarnewstate'];
  ApplicationForm.TBNewState.Hint := App.Trans['toolbarnewstate'] + ' (F3)';
  ApplicationForm.TBNewEventLine.Caption := App.Trans['toolbarneweventline'];
  ApplicationForm.TBNewEventLine.Hint := App.Trans['toolbarneweventline'] + ' (F4)';
  ApplicationForm.TBFitToGrid.Caption := App.Trans['toolbarsnaptogrid'];
  ApplicationForm.TBFitToGrid.Hint := App.Trans['toolbarsnaptogrid'] + ' (F5)';
  ApplicationForm.TBTestSentence.Caption := App.Trans['toolbartestsentence'];
  ApplicationForm.TBTestSentence.Hint := App.Trans['toolbartestsentence'] + ' (F6)';
  ApplicationForm.TBTestSentenceAnim.Caption := App.Trans['toolbartestsentenceanimated'];
  ApplicationForm.TBTestSentenceAnim.Hint := App.Trans['toolbartestsentenceanimated'] + ' (F7)';

  // Popup menu stavov
  ApplicationForm.StatePUMNormalState.Caption := App.Trans['statepum_normal_state'];
  ApplicationForm.StatePUMAcceptState.Caption := App.Trans['statepum_accept_state'];
  ApplicationForm.StatePUMAcceptAndEndState.Caption := App.Trans['statepum_accept_end_state'];
  ApplicationForm.StatePUMFailAndEndState.Caption := App.Trans['statepum_fail_end_state'];
  ApplicationForm.StatePUMMakeFirst.Caption := App.Trans['statepum_make_first'];
  ApplicationForm.StatePUMFirstSub.Caption := App.Trans['statepum_first_sub'];
  ApplicationForm.StatePUMFSRotateArrow.Caption := App.Trans['statepum_fs_rotate_arrow'];
  ApplicationForm.StatePUMDelete.Caption := App.Trans['statepum_delete'];

  // Popup menu udalosti
  ApplicationForm.EventPUMEditSymbols.Caption := App.Trans['eventpum_edit_symbols'];
  ApplicationForm.EventPUMSetRadius.Caption := App.Trans['eventpum_set_radius'];
  ApplicationForm.EventPUMRotate.Caption := App.Trans['eventpum_rotate'];
  ApplicationForm.EventPUMDisplayLabel.Caption := App.Trans['eventpum_label_display'];
  ApplicationForm.EventPUMDelete.Caption := App.Trans['eventpum_delete'];

  if (NewMachineForm <> nil) then
  begin
    // Okno na vytvorenie noveho automatu
    NewMachineForm.Caption := App.Trans['newmachineformcaption'];
    NewMachineForm.InstructionLabel.Caption := App.Trans['newmachine_instruction'];
    NewMachineForm.ChbAlpBinary.Caption := App.Trans['newmachine_checkbox_binary'];
    NewMachineForm.ChbAlpNumbers.Caption := App.Trans['newmachine_checkbox_numbers'];
    NewMachineForm.ChbAlpLowerCaseLetters.Caption := App.Trans['newmachine_checkbox_lowercaseletters'];
    NewMachineForm.ChbAlpUpperCaseLetters.Caption := App.Trans['newmachine_checkbox_uppercaseletters'];
    NewMachineForm.ChbAlpSpecialChars.Caption := App.Trans['newmachine_checkbox_specialchars'];
    NewMachineForm.SpecialCharsHintLabel.Caption := App.Trans['newmachine_specialcharshint'];
    NewMachineForm.BtnCreate.Caption := App.Trans['newmachine_button_create'];
    NewMachineForm.BtnCancel.Caption := App.Trans['newmachine_button_cancel'];
  end;

  if (AboutForm <> nil) then
  begin
    // Okno "o programe"
    AboutForm.Caption := App.Trans['aboutform_caption'];
    AboutForm.LblProgName.Caption := App.Trans['aboutform_appname'];
    AboutForm.LblCopyright.Caption := App.Trans['aboutform_copyright'];
    AboutForm.LblVersion.Caption := App.Trans['aboutform_version'] + ' 1.0.1.120';
  end;
end;

procedure KeyDownHandle(Key: Word; Shift: TShiftState);
begin
  //ShowMessage(IntToStr(Key));

  if Key = 46 then // Delete
  begin
    if App.Animating then Exit;
    App.DeleteSelected;
    App.ForceRenderNextTime;
  end;
  if (Key = 67) and (ssCtrl in Shift) then // Ctrl+C
  begin
    if App.Animating then Exit;
    App.CopySelectedEventSymbols;
  end;
  if Key = 27 then // ESC
  begin
    App.ForceStopAnimation;
  end;
  if Key = 113 then // F2
  begin
    ApplicationForm.TBSelect.Down := true;
    ApplicationForm.TBSelectClick(ApplicationForm.TBSelect);
  end;
  if Key = 114 then // F3
  begin
    ApplicationForm.TBNewState.Down := true;
    ApplicationForm.TBNewStateClick(ApplicationForm.TBNewState);
  end;
  if Key = 115 then // F4
  begin
    ApplicationForm.TBNewEventLine.Down := true;
    ApplicationForm.TBNewEventLineClick(ApplicationForm.TBNewEventLine);
  end;
  if Key = 116 then // F5
  begin
    ApplicationForm.TBFitToGrid.Down := not ApplicationForm.TBFitToGrid.Down;
    ApplicationForm.TBFitToGridClick(ApplicationForm.TBFitToGrid);
  end;
  if Key = 117 then // F6
  begin
    ApplicationForm.TBTestSentenceClick(ApplicationForm.TBTestSentence);
  end;
  if Key = 118 then // F7
  begin
    ApplicationForm.TBTestSentenceAnimClick(ApplicationForm.TBTestSentenceAnim);
  end;
end;

{ TApplicationForm }

procedure TApplicationForm.FormResize(Sender: TObject);
begin
  // Upravi rozmery grafickej plochy a prekresli obsah
  App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
  ReinitializeApplicationImage;
end;

procedure TApplicationForm.FormShow(Sender: TObject);
begin
  App.SetResizeProcedure(@ApplicationForm.OnResizeTick);
  App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
  if not App.LoadGraphicLibraries then
  begin
    ApplicationForm.Close;
    Exit;
  end;
  SetInterfaceGraphics(App);
  App.StartRenderer;
  TBFitToGrid.Down := App.SnapToGrid;
  Sleep(2000);
  App.OnOpen(ApplicationForm);

  if Paramcount = 1 then
  begin
    if FileExists(ParamStr(1)) then
    begin
      App.OpenFileFromAppParameter(ParamStr(1));
    end;
  end;

  // Prekresli obsah grafickej plochy
  ReinitializeApplicationImage;
  RefreshTranslationTexts;
end;

procedure TApplicationForm.MMAboutClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TApplicationForm.MMExitClick(Sender: TObject);
begin
  if App.Animating then Exit;
  ApplicationForm.Close;
end;

procedure TApplicationForm.MMOpenMachineClick(Sender: TObject);
begin
  if App.Animating then Exit;
  if App.Open(MachineOpenDialog) then
  begin
    SBHorizontal.Position := 0;
    SBVertical.Position := 0;
    App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
    ReinitializeApplicationImage;
    RefreshTranslationTexts;
    App.ForceRenderNextTime;
  end;
end;

procedure TApplicationForm.MMSaveMachineAsClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.SaveAs(MachineSaveDialog);
  RefreshTranslationTexts;
end;

procedure TApplicationForm.MMSaveMachineClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.Save(MachineSaveDialog);
  RefreshTranslationTexts;
end;

procedure TApplicationForm.StatePUMAcceptAndEndStateClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.SetStateAsAcceptingAndEnding;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.StatePUMAcceptStateClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.SetStateAsAccepting;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.StatePUMDeleteClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.DeleteSelected;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.StatePUMFailAndEndStateClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.SetStateAsFailedAndEnding;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.MMCloseMachineClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.CloseMachine;
  ReinitializeApplicationImage;
  RefreshTranslationTexts;
end;

procedure TApplicationForm.MMLangDefaultClick(Sender: TObject);
begin
  App.SetAppLanguage('default');

  RefreshTranslationTexts;

  App.RenderAll;
end;

procedure TApplicationForm.MMLangEnglishClick(Sender: TObject);
begin
  App.SetAppLanguage('en');

  RefreshTranslationTexts;

  App.RenderAll;
end;

procedure TApplicationForm.MMNewMachineClick(Sender: TObject);
begin
  if App.Animating then Exit;
  NewMachineForm.Position := poMainFormCenter;
  NewMachineForm.ShowModal;
  RefreshTranslationTexts;
end;

procedure TApplicationForm.SBHorizontalKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  KeyDownHandle(Key, Shift);
end;

procedure TApplicationForm.SBHorizontalScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
  //App.RenderAll;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.SBVerticalKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  KeyDownHandle(Key, Shift);
end;

procedure TApplicationForm.SBVerticalScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
  //App.RenderAll;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.StatePUMFSRotateArrowClick(Sender: TObject);
var
  Output: string;
  Angle: Integer;
begin
  if App.Animating then Exit;
  Output := '';
  if InputQuery(App.Trans['rotate_first_state_arrow_caption'], App.Trans['rotate_first_state_arrow_prompt'], Output) then
  begin
    Angle := StrToIntDef(Output, 0) mod 360;
    App.SetFirstStateArrowAngle(Angle);
    App.ForceRenderNextTime;
  end;
end;

procedure TApplicationForm.StatePUMMakeFirstClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.SetSelectedStateAsFirst;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.StatePUMNormalStateClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.SetStateAsNormal;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.TBFitToGridClick(Sender: TObject);
begin
  App.SnapToGrid := TBFitToGrid.Down;
end;

procedure TApplicationForm.TBNewEventLineClick(Sender: TObject);
begin
  TBSelect.Down := false;
  TBNewState.Down := false;
end;

procedure TApplicationForm.TBNewStateClick(Sender: TObject);
begin
  TBNewEventLine.Down := false;
  TBSelect.Down := false;
end;

procedure TApplicationForm.TBSelectClick(Sender: TObject);
begin
  TBNewState.Down := false;
  TBNewEventLine.Down := false;
end;

procedure TApplicationForm.TBTestSentenceAnimClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.TestSentenceAnimated(@ApplicationForm.OnAnimationDone);
end;

procedure TApplicationForm.TBTestSentenceClick(Sender: TObject);
var
  Res: TDetermineReturn;
begin
  if App.Animating then Exit;
  Res := App.TestSentence;
  if Res = drAccepted then
    MessageDlg(App.Trans['machine_test_sentence_caption'], App.Trans['machine_test_sentence_accepted'], mtInformation, [mbOK], 0)
  else if Res = drRefused then
    MessageDlg(App.Trans['machine_test_sentence_caption'], App.Trans['machine_test_sentence_refused'], mtInformation, [mbOK], 0);
end;

procedure TApplicationForm.OnAnimationDone;
begin
  if App.AnimTestResult = drAccepted then
    MessageDlg(App.Trans['machine_test_sentence_caption'], App.Trans['machine_test_sentence_accepted'], mtInformation, [mbOK], 0)
  else if App.AnimTestResult = drRefused then
    MessageDlg(App.Trans['machine_test_sentence_caption'], App.Trans['machine_test_sentence_refused'], mtInformation, [mbOK], 0);
  App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.OnResizeTick;
begin
  // Prisposoby vnutorny rozmer
  if ApplicationForm.ApplicationImage.Picture.Bitmap.Width <> ApplicationForm.ApplicationImage.Width then
    ApplicationForm.ApplicationImage.Picture.Bitmap.Width := ApplicationForm.ApplicationImage.Width;
  if ApplicationForm.ApplicationImage.Picture.Bitmap.Height <> ApplicationForm.ApplicationImage.Height then
    ApplicationForm.ApplicationImage.Picture.Bitmap.Height := ApplicationForm.ApplicationImage.Height;

  App.SetScreenAndOffset(ApplicationImage.Width, ApplicationImage.Height, SBHorizontal.Position * (-1), SBVertical.Position * (-1));
end;

procedure TApplicationForm.FormCreate(Sender: TObject);
var
  AppPath: string;
begin
  DoubleBuffered := true;

  AppPath := ExtractFilePath(Application.ExeName);
  {$IFDEF DARWIN}
  AppPath := LeftStr(g_path, Pos('myapp.app', g_path)-1);
  {$ENDIF}

  App := TApplicationControl.Create(ApplicationImage, AppPath);
end;

procedure TApplicationForm.ApplicationImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if App.Animating then Exit;
  if App.MachineExists then
  begin
    if TBNewState.Down and (Button = mbLeft) then
    begin
      App.MachineCreateState(X, Y);
    end;

    if TBSelect.Down and ((Button = mbLeft) or (Button = mbRight)) then
    begin
      App.SelectObjectAtXY(X, Y);
      if (Button = mbLeft) and App.IsStateSelected then
        StateMovement := True;

      if (Button = mbRight) and App.IsStateSelected then
      begin
        if not App.IsFirstStateSelected then
        begin
          StatePUMMakeFirst.Enabled := true;
          StatePUMFirstSub.Enabled := False;
        end
        else
        begin
          StatePUMMakeFirst.Enabled := false;
          StatePUMFirstSub.Enabled := true;
        end;

        App.RenderAll;
        StatePopupMenu.PopUp;
      end
      else if (Button = mbRight) and App.IsEventSelected then
      begin
        if not App.IsCyclicEventSelected then
        begin
          EventPUMRotate.Enabled := false;
          EventPUMSetRadius.Enabled := false;
        end
        else
        begin
          EventPUMRotate.Enabled := true;
          EventPUMSetRadius.Enabled := true;
        end;

        if not App.IsElseEventSelected then
          EventPUMEditSymbols.Enabled := true
        else
          EventPUMEditSymbols.Enabled := false;

        EventPUMDisplayLabel.Checked := App.IsEventLabelDisplaing;

        if EventPUMDisplayLabel.Checked then
          EventPUMDisplayLabel.ImageIndex := 4
        else
          EventPUMDisplayLabel.ImageIndex := 5;

        App.RenderAll;
        EventPopupMenu.PopUp;
      end;
    end;

    if TBNewEventLine.Down and (Button = mbLeft) then
    begin
      App.SelectObjectAtXY(X, Y);
      App.MakeNewStateEvent;
    end;

    App.RenderAll;
  end;
end;

procedure TApplicationForm.ApplicationImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if App.Animating then Exit;
  if App.MachineExists then
  begin
    if TBSelect.Down and StateMovement then
    begin
      App.MoveStateToXY(X, Y);
      App.ForceRenderNextTime;
    end;
  end;
end;

procedure TApplicationForm.ApplicationImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if App.Animating then Exit;
  if App.MachineExists then
  begin
    if TBSelect.Down and (Button = mbLeft) then
    begin
      StateMovement := false;
    end;
  end;
end;

procedure TApplicationForm.EventPUMDeleteClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.DeleteSelected;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.EventPUMDisplayLabelClick(Sender: TObject);
begin
  if App.Animating then Exit;
  EventPUMDisplayLabel.Checked := not EventPUMDisplayLabel.Checked;

  if EventPUMDisplayLabel.Checked then
    EventPUMDisplayLabel.ImageIndex := 4
  else
    EventPUMDisplayLabel.ImageIndex := 5;

  App.SetEventLabelDisplaing(EventPUMDisplayLabel.Checked);
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.EventPUMEditSymbolsClick(Sender: TObject);
begin
  if App.Animating then Exit;
  App.EditStateEvent;
  App.ForceRenderNextTime;
end;

procedure TApplicationForm.EventPUMRotateClick(Sender: TObject);
var
  Output: string;
  Angle: Integer;
begin
  if App.Animating then Exit;
  Output := '';
  if InputQuery(App.Trans['rotate_state_event_caption'], App.Trans['rotate_state_event_prompt'], Output) then
  begin
    Angle := StrToIntDef(Output, 0) mod 360;
    App.SetCyclicEventAngle(Angle);
    App.ForceRenderNextTime;
  end;
end;

procedure TApplicationForm.EventPUMSetRadiusClick(Sender: TObject);
var
  Output: string;
  Radius: Integer;
begin
  if App.Animating then Exit;
  Output := '';
  if InputQuery(App.Trans['set_state_event_radius_caption'], App.Trans['set_state_event_radius_prompt'], Output) then
  begin
    Radius := StrToIntDef(Output, 0);
    if Radius < 30 then Radius := 30 else if Radius > 150 then Radius := 150;
    App.SetCyclicEventRadius(Radius);
    App.ForceRenderNextTime;
  end;
end;

procedure TApplicationForm.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  if not App.OnClose(ApplicationForm) then
    CloseAction := caNone;
end;

procedure TApplicationForm.FormDestroy(Sender: TObject);
begin
  App.Free;
end;

procedure TApplicationForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  KeyDownHandle(Key, Shift);
end;

end.

