unit Unit2; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TNewMachineForm }

  TNewMachineForm = class(TForm)
    BtnCreate: TButton;
    BtnCancel: TButton;
    ChbAlpBinary: TCheckBox;
    ChbAlpNumbers: TCheckBox;
    ChbAlpLowerCaseLetters: TCheckBox;
    ChbAlpUpperCaseLetters: TCheckBox;
    ChbAlpSpecialChars: TCheckBox;
    GroupBox1: TGroupBox;
    InstructionLabel: TLabel;
    SpecialCharsHintLabel: TLabel;
    SpecialCharsLabel: TLabel;
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnCreateClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  NewMachineForm: TNewMachineForm;

implementation

uses
  unit1, machine;

procedure CleanUp;
begin
  NewMachineForm.ChbAlpBinary.Checked := false;
  NewMachineForm.ChbAlpNumbers.Checked := false;
  NewMachineForm.ChbAlpLowerCaseLetters.Checked := false;
  NewMachineForm.ChbAlpUpperCaseLetters.Checked := false;
  NewMachineForm.ChbAlpSpecialChars.Checked := false;
end;

{ TNewMachineForm }

procedure TNewMachineForm.BtnCreateClick(Sender: TObject);
var
  Alpha: TMachineAlphabet;
begin
  Alpha := [];
  if ChbAlpBinary.Checked then
    Alpha := Alpha + ['0','1'];
  if ChbAlpNumbers.Checked then
    Alpha := Alpha + ['0'..'9'];
  if ChbAlpLowerCaseLetters.Checked then
    Alpha := Alpha + ['a'..'z'];
  if ChbAlpUpperCaseLetters.Checked then
    Alpha := Alpha + ['A'..'Z'];
  if ChbAlpSpecialChars.Checked then
    Alpha := Alpha + ['_','+','-','=',',','.','[',']','{','}','(',')','@','!','?','#','$','%','^','*','/','\'];
  if App.CreateNewMachine(Alpha) then
  begin
    CleanUp;
    NewMachineForm.Close;
  end;
end;

procedure TNewMachineForm.BtnCancelClick(Sender: TObject);
begin
  CleanUp;
  NewMachineForm.Close;
end;

{$R *.lfm}

end.

